/* clock.c generated by valac 0.54.6, the Vala compiler
 * generated from clock.vala, do not modify */

/*
 * vala-panel
 * Copyright (C) 2015 Konstantin Pugin <ria.freelander@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <applet-widget.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <toplevel.h>
#include <gio/gio.h>
#include <applet-widget-api.h>
#include <misc-gtk.h>
#include <css.h>
#include <generic-config-dialog.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <definitions.h>
#include <panel-platform.h>
#include <applet-info.h>

#define CLOCK_TIP_FORMAT "tooltip-format"
#define CLOCK_LABEL_FORMAT "clock-format"
#define CLOCK_BOLD "bold-font"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_CLOCK (clock_get_type ())
#define CLOCK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CLOCK, Clock))
#define CLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CLOCK, ClockClass))
#define IS_CLOCK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CLOCK))
#define IS_CLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CLOCK))
#define CLOCK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CLOCK, ClockClass))

typedef struct _Clock Clock;
typedef struct _ClockClass ClockClass;
typedef struct _ClockPrivate ClockPrivate;
typedef enum  {
	CLOCK_INTERVAL_AWAITING_FIRST_CHANGE = 0,
	CLOCK_INTERVAL_AWAITING_SECOND_CHANGE = 1,
	CLOCK_INTERVAL_ONE_SECOND = 2,
	CLOCK_INTERVAL_ONE_MINUTE = 3
} ClockInterval;

#define CLOCK_TYPE_INTERVAL (clock_interval_get_type ())
enum  {
	CLOCK_0_PROPERTY,
	CLOCK_CLOCK_FORMAT_PROPERTY,
	CLOCK_TOOLTIP_FORMAT_PROPERTY,
	CLOCK_BOLD_FONT_PROPERTY,
	CLOCK_NUM_PROPERTIES
};
static GParamSpec* clock_properties[CLOCK_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

struct _Clock {
	ValaPanelApplet parent_instance;
	ClockPrivate * priv;
};

struct _ClockClass {
	ValaPanelAppletClass parent_class;
};

struct _ClockPrivate {
	GtkToggleButton* clock;
	ClockInterval exp_interval;
	gint exp_count;
	gchar* prev_clock_val;
	guint timer;
	GtkWindow* calendar;
	gchar* _clock_format;
	gchar* _tooltip_format;
	gboolean _bold_font;
};

static gint Clock_private_offset;
static gpointer clock_parent_class = NULL;
static GType clock_type_id = 0;

GType clock_register_type (GTypeModule * module);
VALA_EXTERN GType clock_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Clock, g_object_unref)
static GType clock_interval_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
VALA_EXTERN Clock* clock_new (ValaPanelToplevel* toplevel,
                  GSettings* settings,
                  const gchar* number);
VALA_EXTERN Clock* clock_construct (GType object_type,
                        ValaPanelToplevel* toplevel,
                        GSettings* settings,
                        const gchar* number);
static void clock_real_constructed (GObject* base);
static void __lambda4_ (Clock* self);
static GtkWindow* clock_create_calendar (Clock* self);
static void ___lambda4__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                            gpointer self);
static void __lambda5_ (Clock* self,
                 GParamSpec* pspec);
static gchar* clock_get_css (Clock* self);
static void clock_timer_set (Clock* self,
                      GDateTime* current_time);
static void ___lambda5__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static GtkWidget* clock_real_get_settings_ui (ValaPanelApplet* base);
static void clock_popup_position_helper (Clock* self,
                                  GtkWidget* popup,
                                  gint* x,
                                  gint* y);
static void clock_set_popup_position (Clock* self,
                               GtkWidget* popup);
VALA_EXTERN gboolean clock_get_bold_font (Clock* self);
static gboolean clock_update_display (Clock* self);
VALA_EXTERN const gchar* clock_get_clock_format (Clock* self);
VALA_EXTERN const gchar* clock_get_tooltip_format (Clock* self);
static gboolean _clock_update_display_gsource_func (gpointer self);
VALA_EXTERN void clock_set_clock_format (Clock* self,
                             const gchar* value);
VALA_EXTERN void clock_set_tooltip_format (Clock* self,
                               const gchar* value);
VALA_EXTERN void clock_set_bold_font (Clock* self,
                          gboolean value);
static void clock_finalize (GObject * obj);
static void _vala_clock_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec);
static void _vala_clock_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec);
VALA_EXTERN void g_io_clock_load (GTypeModule* module);
VALA_EXTERN void g_io_clock_unload (GIOModule* module);

static inline gpointer
clock_get_instance_private (Clock* self)
{
	return G_STRUCT_MEMBER_P (self, Clock_private_offset);
}

static GType
clock_interval_get_type_once (void)
{
	static const GEnumValue values[] = {{CLOCK_INTERVAL_AWAITING_FIRST_CHANGE, "CLOCK_INTERVAL_AWAITING_FIRST_CHANGE", "awaiting-first-change"}, {CLOCK_INTERVAL_AWAITING_SECOND_CHANGE, "CLOCK_INTERVAL_AWAITING_SECOND_CHANGE", "awaiting-second-change"}, {CLOCK_INTERVAL_ONE_SECOND, "CLOCK_INTERVAL_ONE_SECOND", "one-second"}, {CLOCK_INTERVAL_ONE_MINUTE, "CLOCK_INTERVAL_ONE_MINUTE", "one-minute"}, {0, NULL, NULL}};
	GType clock_interval_type_id;
	clock_interval_type_id = g_enum_register_static ("ClockInterval", values);
	return clock_interval_type_id;
}

static GType
clock_interval_get_type (void)
{
	static volatile gsize clock_interval_type_id__volatile = 0;
	if (g_once_init_enter (&clock_interval_type_id__volatile)) {
		GType clock_interval_type_id;
		clock_interval_type_id = clock_interval_get_type_once ();
		g_once_init_leave (&clock_interval_type_id__volatile, clock_interval_type_id);
	}
	return clock_interval_type_id__volatile;
}

Clock*
clock_construct (GType object_type,
                 ValaPanelToplevel* toplevel,
                 GSettings* settings,
                 const gchar* number)
{
	Clock * self = NULL;
#line 43 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_return_val_if_fail (toplevel != NULL, NULL);
#line 43 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_return_val_if_fail (number != NULL, NULL);
#line 47 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	self = (Clock*) vala_panel_applet_construct (object_type, toplevel, settings, number);
#line 43 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	return self;
#line 206 "clock.c"
}

Clock*
clock_new (ValaPanelToplevel* toplevel,
           GSettings* settings,
           const gchar* number)
{
#line 43 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	return clock_construct (TYPE_CLOCK, toplevel, settings, number);
#line 216 "clock.c"
}

static void
__lambda4_ (Clock* self)
{
	GtkToggleButton* _tmp0_;
#line 58 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp0_ = self->priv->clock;
#line 58 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	if (gtk_toggle_button_get_active (_tmp0_)) {
#line 227 "clock.c"
		GtkWindow* _tmp1_;
		GtkWindow* _tmp2_;
#line 60 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_tmp1_ = clock_create_calendar (self);
#line 60 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_g_object_unref0 (self->priv->calendar);
#line 60 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		self->priv->calendar = _tmp1_;
#line 61 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_tmp2_ = self->priv->calendar;
#line 61 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		gtk_widget_show ((GtkWidget*) _tmp2_);
#line 240 "clock.c"
	} else {
		GtkWindow* _tmp3_;
#line 65 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_tmp3_ = self->priv->calendar;
#line 65 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		gtk_widget_destroy ((GtkWidget*) _tmp3_);
#line 66 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_g_object_unref0 (self->priv->calendar);
#line 66 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		self->priv->calendar = NULL;
#line 251 "clock.c"
	}
}

static void
___lambda4__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                       gpointer self)
{
#line 57 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	__lambda4_ ((Clock*) self);
#line 261 "clock.c"
}

static void
__lambda5_ (Clock* self,
            GParamSpec* pspec)
{
	const gchar* _tmp0_;
#line 69 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_return_if_fail (pspec != NULL);
#line 70 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp0_ = pspec->name;
#line 70 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	if (g_strcmp0 (_tmp0_, CLOCK_BOLD) == 0) {
#line 275 "clock.c"
		GtkToggleButton* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 71 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_tmp1_ = self->priv->clock;
#line 71 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_tmp2_ = clock_get_css (self);
#line 71 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_tmp3_ = _tmp2_;
#line 71 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		css_apply_with_class ((GtkWidget*) _tmp1_, _tmp3_, "-vala-panel-font-weight", FALSE);
#line 71 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_g_free0 (_tmp3_);
#line 289 "clock.c"
	} else {
		GDateTime* now = NULL;
		GDateTime* _tmp4_;
		GDateTime* _tmp5_;
		GtkWindow* _tmp6_;
#line 74 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		if (self->priv->timer != ((guint) 0)) {
#line 74 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
			g_source_remove (self->priv->timer);
#line 299 "clock.c"
		}
#line 75 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_g_free0 (self->priv->prev_clock_val);
#line 75 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		self->priv->prev_clock_val = NULL;
#line 76 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		self->priv->exp_count = 0;
#line 77 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		self->priv->exp_interval = CLOCK_INTERVAL_AWAITING_FIRST_CHANGE;
#line 78 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_tmp4_ = g_date_time_new_now_local ();
#line 78 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		now = _tmp4_;
#line 79 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_tmp5_ = now;
#line 79 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		clock_timer_set (self, _tmp5_);
#line 80 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_tmp6_ = self->priv->calendar;
#line 80 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		if (_tmp6_ != NULL) {
#line 321 "clock.c"
			GtkWindow* _tmp7_;
#line 82 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
			_tmp7_ = self->priv->calendar;
#line 82 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
			gtk_widget_destroy ((GtkWidget*) _tmp7_);
#line 83 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
			_g_object_unref0 (self->priv->calendar);
#line 83 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
			self->priv->calendar = NULL;
#line 331 "clock.c"
		}
#line 70 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_g_date_time_unref0 (now);
#line 335 "clock.c"
	}
}

static void
___lambda5__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
#line 69 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	__lambda5_ ((Clock*) self, pspec);
#line 346 "clock.c"
}

static void
clock_real_constructed (GObject* base)
{
	Clock * self;
	GSimpleActionGroup* _tmp0_;
	GSimpleActionGroup* _tmp1_;
	GAction* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	GtkToggleButton* _tmp9_;
	GtkToggleButton* _tmp10_;
	GtkToggleButton* _tmp11_;
	GtkToggleButton* _tmp12_;
	GtkToggleButton* _tmp13_;
#line 49 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	self = (Clock*) base;
#line 51 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp0_ = vala_panel_applet_get_action_group ((ValaPanelApplet*) self);
#line 51 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp1_ = _tmp0_;
#line 51 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp2_ = g_action_map_lookup_action ((GActionMap*) _tmp1_, VALA_PANEL_APPLET_ACTION_CONFIGURE);
#line 51 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp2_) : NULL, TRUE);
#line 52 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp3_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
#line 52 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp4_ = _tmp3_;
#line 52 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_settings_bind (_tmp4_, CLOCK_LABEL_FORMAT, (GObject*) self, CLOCK_LABEL_FORMAT, G_SETTINGS_BIND_GET);
#line 53 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp5_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
#line 53 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp6_ = _tmp5_;
#line 53 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_settings_bind (_tmp6_, CLOCK_TIP_FORMAT, (GObject*) self, CLOCK_TIP_FORMAT, G_SETTINGS_BIND_GET);
#line 54 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp7_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
#line 54 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp8_ = _tmp7_;
#line 54 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_settings_bind (_tmp8_, CLOCK_BOLD, (GObject*) self, CLOCK_BOLD, G_SETTINGS_BIND_GET);
#line 55 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp9_ = (GtkToggleButton*) gtk_toggle_button_new ();
#line 55 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_object_ref_sink (_tmp9_);
#line 55 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_g_object_unref0 (self->priv->clock);
#line 55 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	self->priv->clock = _tmp9_;
#line 56 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp10_ = self->priv->clock;
#line 56 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	vala_panel_setup_button (G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, gtk_button_get_type ()) ? ((GtkButton*) _tmp10_) : NULL, NULL, NULL);
#line 57 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp11_ = self->priv->clock;
#line 57 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_signal_connect_object (_tmp11_, "toggled", (GCallback) ___lambda4__gtk_toggle_button_toggled, self, 0);
#line 69 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) ___lambda5__g_object_notify, self, 0);
#line 87 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp12_ = self->priv->clock;
#line 87 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	gtk_widget_show ((GtkWidget*) _tmp12_);
#line 88 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp13_ = self->priv->clock;
#line 88 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp13_);
#line 89 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	gtk_widget_show ((GtkWidget*) self);
#line 423 "clock.c"
}

static GtkWidget*
clock_real_get_settings_ui (ValaPanelApplet* base)
{
	Clock * self;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* result = NULL;
#line 91 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	self = (Clock*) base;
#line 93 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp0_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
#line 93 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp1_ = _tmp0_;
#line 93 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp2_ = generic_config_widget (_tmp1_, _ ("Clock Format"), CLOCK_LABEL_FORMAT, CONF_STR, _ ("Tooltip Format"), CLOCK_TIP_FORMAT, CONF_STR, _ ("Format codes: man 3 strftime; %n for line break"), NULL, CONF_TRIM, _ ("Bold font"), CLOCK_BOLD, CONF_BOOL, NULL);
#line 93 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	result = _tmp2_;
#line 93 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	return result;
#line 446 "clock.c"
}

static void
clock_popup_position_helper (Clock* self,
                             GtkWidget* popup,
                             gint* x,
                             gint* y)
{
	gint _vala_x = 0;
	gint _vala_y = 0;
	GtkAllocation pa = {0};
	GtkAllocation a = {0};
	GtkAllocation _tmp0_ = {0};
	GtkAllocation _tmp10_ = {0};
	GdkWindow* _tmp11_;
	gint _tmp12_ = 0;
	gint _tmp13_ = 0;
	GtkPositionType edge = 0;
	ValaPanelToplevel* _tmp16_;
	ValaPanelToplevel* _tmp17_;
	PanelGravity _tmp18_;
	PanelGravity _tmp19_;
	GdkMonitor* monitor = NULL;
	GdkDisplay* _tmp24_;
	GdkMonitor* _tmp25_;
	GdkRectangle _tmp26_ = {0};
	GtkAllocation _tmp27_;
	GtkAllocation _tmp28_;
	GtkAllocation _tmp29_;
	GtkAllocation _tmp30_;
	GtkAllocation _tmp31_;
	GtkAllocation _tmp32_;
	GtkAllocation _tmp33_;
	GtkAllocation _tmp34_;
#line 99 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_return_if_fail (self != NULL);
#line 99 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_return_if_fail (popup != NULL);
#line 104 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	gtk_widget_realize (popup);
#line 105 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	gtk_widget_get_allocation (popup, &_tmp0_);
#line 105 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	pa = _tmp0_;
#line 106 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	if (gtk_widget_is_toplevel (popup)) {
#line 493 "clock.c"
		GdkRectangle ext = {0};
		GdkWindow* _tmp1_;
		GdkRectangle _tmp2_ = {0};
		GdkRectangle _tmp3_;
		GdkRectangle _tmp4_;
#line 109 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_tmp1_ = gtk_widget_get_window (popup);
#line 109 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		gdk_window_get_frame_extents (_tmp1_, &_tmp2_);
#line 109 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		ext = _tmp2_;
#line 110 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_tmp3_ = ext;
#line 110 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		pa.width = _tmp3_.width;
#line 111 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_tmp4_ = ext;
#line 111 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		pa.height = _tmp4_.height;
#line 513 "clock.c"
	}
#line 113 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (popup, gtk_menu_get_type ())) {
#line 517 "clock.c"
		gint min = 0;
		gint nat = 0;
		gint new_height = 0;
		GList* _tmp5_;
		GtkAllocation _tmp9_;
#line 115 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		new_height = 0;
#line 116 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_tmp5_ = gtk_container_get_children ((GtkContainer*) (G_TYPE_CHECK_INSTANCE_TYPE (popup, gtk_menu_get_type ()) ? ((GtkMenu*) popup) : NULL));
#line 527 "clock.c"
		{
			GList* item_collection = NULL;
			GList* item_it = NULL;
#line 116 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
			item_collection = _tmp5_;
#line 116 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
			for (item_it = item_collection; item_it != NULL; item_it = item_it->next) {
#line 535 "clock.c"
				GtkWidget* item = NULL;
#line 116 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
				item = (GtkWidget*) item_it->data;
#line 539 "clock.c"
				{
					GtkWidget* _tmp6_;
					gint _tmp7_ = 0;
					gint _tmp8_ = 0;
#line 118 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
					_tmp6_ = item;
#line 118 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
					gtk_widget_get_preferred_height (_tmp6_, &_tmp7_, &_tmp8_);
#line 118 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
					min = _tmp7_;
#line 118 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
					nat = _tmp8_;
#line 119 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
					new_height += nat;
#line 554 "clock.c"
				}
			}
#line 116 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
			(item_collection == NULL) ? NULL : (item_collection = (g_list_free (item_collection), NULL));
#line 559 "clock.c"
		}
#line 121 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_tmp9_ = pa;
#line 121 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		pa.height = MAX (_tmp9_.height, new_height);
#line 565 "clock.c"
	}
#line 123 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp10_);
#line 123 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	a = _tmp10_;
#line 124 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp11_ = gtk_widget_get_window ((GtkWidget*) self);
#line 124 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	gdk_window_get_origin (_tmp11_, &_tmp12_, &_tmp13_);
#line 124 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_vala_x = _tmp12_;
#line 124 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_vala_y = _tmp13_;
#line 125 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	if (!gtk_widget_get_has_window ((GtkWidget*) self)) {
#line 581 "clock.c"
		GtkAllocation _tmp14_;
		GtkAllocation _tmp15_;
#line 127 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_tmp14_ = a;
#line 127 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_vala_x = _vala_x + _tmp14_.x;
#line 128 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_tmp15_ = a;
#line 128 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_vala_y = _vala_y + _tmp15_.y;
#line 592 "clock.c"
	}
#line 130 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp16_ = vala_panel_applet_get_toplevel ((ValaPanelApplet*) self);
#line 130 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp17_ = _tmp16_;
#line 130 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_object_get (_tmp17_, "panel-gravity", &_tmp18_, NULL);
#line 130 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp19_ = _tmp18_;
#line 130 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	edge = vala_panel_edge_from_gravity (_tmp19_);
#line 131 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	switch (edge) {
#line 131 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		case GTK_POS_TOP:
#line 608 "clock.c"
		{
			GtkAllocation _tmp20_;
#line 134 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
			_tmp20_ = a;
#line 134 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
			_vala_y = _vala_y + _tmp20_.height;
#line 135 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
			break;
#line 617 "clock.c"
		}
#line 131 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		case GTK_POS_BOTTOM:
#line 621 "clock.c"
		{
			GtkAllocation _tmp21_;
#line 137 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
			_tmp21_ = pa;
#line 137 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
			_vala_y = _vala_y - _tmp21_.height;
#line 138 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
			break;
#line 630 "clock.c"
		}
#line 131 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		case GTK_POS_LEFT:
#line 634 "clock.c"
		{
			GtkAllocation _tmp22_;
#line 140 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
			_tmp22_ = a;
#line 140 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
			_vala_x = _vala_x + _tmp22_.width;
#line 141 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
			break;
#line 643 "clock.c"
		}
#line 131 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		case GTK_POS_RIGHT:
#line 647 "clock.c"
		{
			GtkAllocation _tmp23_;
#line 143 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
			_tmp23_ = pa;
#line 143 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
			_vala_x = _vala_x - _tmp23_.width;
#line 144 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
			break;
#line 656 "clock.c"
		}
		default:
#line 131 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		break;
#line 661 "clock.c"
	}
#line 146 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp24_ = gtk_widget_get_display ((GtkWidget*) self);
#line 146 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp25_ = gdk_display_get_monitor_at_point (_tmp24_, _vala_x, _vala_y);
#line 146 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	monitor = _tmp25_;
#line 147 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	gdk_monitor_get_workarea (monitor, &_tmp26_);
#line 147 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	a = (GtkAllocation) _tmp26_;
#line 148 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp27_ = a;
#line 148 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp28_ = a;
#line 148 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp29_ = a;
#line 148 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp30_ = pa;
#line 148 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_vala_x = CLAMP (_vala_x, _tmp27_.x, (_tmp28_.x + _tmp29_.width) - _tmp30_.width);
#line 149 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp31_ = a;
#line 149 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp32_ = a;
#line 149 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp33_ = a;
#line 149 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp34_ = pa;
#line 149 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_vala_y = CLAMP (_vala_y, _tmp31_.y, (_tmp32_.y + _tmp33_.height) - _tmp34_.height);
#line 99 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	if (x) {
#line 99 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		*x = _vala_x;
#line 697 "clock.c"
	}
#line 99 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	if (y) {
#line 99 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		*y = _vala_y;
#line 703 "clock.c"
	}
}

static void
clock_set_popup_position (Clock* self,
                          GtkWidget* popup)
{
	gint x = 0;
	gint y = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
#line 151 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_return_if_fail (self != NULL);
#line 151 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_return_if_fail (popup != NULL);
#line 154 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	clock_popup_position_helper (self, popup, &_tmp0_, &_tmp1_);
#line 154 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	x = _tmp0_;
#line 154 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	y = _tmp1_;
#line 155 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (popup, gtk_window_get_type ())) {
#line 156 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		gtk_window_move (G_TYPE_CHECK_INSTANCE_TYPE (popup, gtk_window_get_type ()) ? ((GtkWindow*) popup) : NULL, x, y);
#line 729 "clock.c"
	} else {
		GdkWindow* _tmp2_;
#line 158 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_tmp2_ = gtk_widget_get_window (popup);
#line 158 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		gdk_window_move (_tmp2_, x, y);
#line 736 "clock.c"
	}
}

static gchar*
clock_get_css (Clock* self)
{
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* result = NULL;
#line 160 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 163 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp1_ = self->priv->_bold_font;
#line 163 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	if (_tmp1_) {
#line 163 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_tmp0_ = "bold";
#line 760 "clock.c"
	} else {
#line 163 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_tmp0_ = "normal";
#line 764 "clock.c"
	}
#line 162 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp2_ = g_strdup_printf (" font-weight: %s;\n", _tmp0_);
#line 162 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp3_ = _tmp2_;
#line 162 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp4_ = g_strconcat (".-vala-panel-font-weight{\n", _tmp3_, NULL);
#line 162 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp5_ = _tmp4_;
#line 162 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp6_ = g_strconcat (_tmp5_, "}", NULL);
#line 162 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp7_ = _tmp6_;
#line 162 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_g_free0 (_tmp5_);
#line 162 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_g_free0 (_tmp3_);
#line 162 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	result = _tmp7_;
#line 162 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	return result;
#line 786 "clock.c"
}

static GtkWindow*
clock_create_calendar (Clock* self)
{
	GtkWindow* win = NULL;
	GtkWindow* _tmp0_;
	GtkCalendar* calendar = NULL;
	GtkCalendar* _tmp1_;
	GDateTime* now = NULL;
	GDateTime* _tmp2_;
	ValaPanelToplevel* _tmp3_;
	ValaPanelToplevel* _tmp4_;
	ValaPanelToplevel* _tmp5_;
	ValaPanelToplevel* _tmp6_;
	GtkWindow* result = NULL;
#line 166 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 169 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp0_ = (GtkWindow*) gtk_window_new (GTK_WINDOW_POPUP);
#line 169 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_object_ref_sink (_tmp0_);
#line 169 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	win = _tmp0_;
#line 170 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	gtk_window_set_default_size (win, 180, 180);
#line 171 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	gtk_container_set_border_width ((GtkContainer*) win, (guint) 5);
#line 173 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp1_ = (GtkCalendar*) gtk_calendar_new ();
#line 173 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_object_ref_sink (_tmp1_);
#line 173 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	calendar = _tmp1_;
#line 174 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp2_ = g_date_time_new_now_local ();
#line 174 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	now = _tmp2_;
#line 175 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	gtk_calendar_set_display_options (calendar, (GTK_CALENDAR_SHOW_WEEK_NUMBERS | GTK_CALENDAR_SHOW_DAY_NAMES) | GTK_CALENDAR_SHOW_HEADING);
#line 178 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	gtk_calendar_mark_day (calendar, (guint) g_date_time_get_day_of_month (now));
#line 179 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	gtk_container_add ((GtkContainer*) win, (GtkWidget*) calendar);
#line 181 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	gtk_window_set_type_hint (win, GDK_WINDOW_TYPE_HINT_UTILITY);
#line 182 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp3_ = vala_panel_applet_get_toplevel ((ValaPanelApplet*) self);
#line 182 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp4_ = _tmp3_;
#line 182 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	gtk_window_set_transient_for (win, (GtkWindow*) _tmp4_);
#line 183 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp5_ = vala_panel_applet_get_toplevel ((ValaPanelApplet*) self);
#line 183 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp6_ = _tmp5_;
#line 183 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	gtk_window_set_attached_to (win, (GtkWidget*) _tmp6_);
#line 184 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	gtk_widget_show ((GtkWidget*) calendar);
#line 185 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	clock_set_popup_position (self, (GtkWidget*) win);
#line 187 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	result = win;
#line 187 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_g_date_time_unref0 (now);
#line 187 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_g_object_unref0 (calendar);
#line 187 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	return result;
#line 857 "clock.c"
}

static gboolean
clock_update_display (Clock* self)
{
	GDateTime* now = NULL;
	GDateTime* _tmp0_;
	GSource* _tmp1_;
	GDateTime* _tmp2_;
	gchar* label = NULL;
	GDateTime* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* tooltip = NULL;
	GDateTime* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	GtkToggleButton* _tmp9_;
	const gchar* _tmp10_;
	GtkToggleButton* _tmp11_;
	const gchar* _tmp12_;
	gboolean result = FALSE;
#line 191 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 194 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 194 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	now = _tmp0_;
#line 196 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp1_ = g_main_current_source ();
#line 196 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	if (g_source_is_destroyed (_tmp1_)) {
#line 197 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		result = FALSE;
#line 197 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_g_date_time_unref0 (now);
#line 197 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		return result;
#line 896 "clock.c"
	}
#line 199 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp2_ = now;
#line 199 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	clock_timer_set (self, _tmp2_);
#line 202 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp3_ = now;
#line 202 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp4_ = self->priv->_clock_format;
#line 202 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp5_ = g_date_time_format (_tmp3_, _tmp4_);
#line 202 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	label = _tmp5_;
#line 203 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp6_ = now;
#line 203 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp7_ = self->priv->_tooltip_format;
#line 203 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp8_ = g_date_time_format (_tmp6_, _tmp7_);
#line 203 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	tooltip = _tmp8_;
#line 207 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp9_ = self->priv->clock;
#line 207 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp10_ = label;
#line 207 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	gtk_button_set_label ((GtkButton*) _tmp9_, _tmp10_);
#line 208 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp11_ = self->priv->clock;
#line 208 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp12_ = tooltip;
#line 208 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp11_, _tmp12_);
#line 213 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	if (self->priv->exp_interval < CLOCK_INTERVAL_ONE_SECOND) {
#line 932 "clock.c"
		const gchar* _tmp13_;
#line 215 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_tmp13_ = self->priv->prev_clock_val;
#line 215 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		if (_tmp13_ == NULL) {
#line 938 "clock.c"
			const gchar* _tmp14_;
			gchar* _tmp15_;
#line 217 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
			_tmp14_ = label;
#line 217 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
			_tmp15_ = g_strdup (_tmp14_);
#line 217 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
			_g_free0 (self->priv->prev_clock_val);
#line 217 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
			self->priv->prev_clock_val = _tmp15_;
#line 949 "clock.c"
		} else {
			const gchar* _tmp16_;
			const gchar* _tmp17_;
#line 220 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
			_tmp16_ = self->priv->prev_clock_val;
#line 220 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
			_tmp17_ = label;
#line 220 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
			if (g_strcmp0 (_tmp16_, _tmp17_) == 0) {
#line 222 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
				self->priv->exp_count = self->priv->exp_count + 1;
#line 223 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
				if (self->priv->exp_count > 3) {
#line 226 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
					self->priv->exp_interval = CLOCK_INTERVAL_ONE_MINUTE;
#line 227 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
					_g_free0 (self->priv->prev_clock_val);
#line 227 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
					self->priv->prev_clock_val = NULL;
#line 969 "clock.c"
				}
			} else {
#line 230 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
				if (self->priv->exp_interval == CLOCK_INTERVAL_AWAITING_FIRST_CHANGE) {
#line 974 "clock.c"
					const gchar* _tmp18_;
					gchar* _tmp19_;
#line 234 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
					self->priv->exp_interval = CLOCK_INTERVAL_AWAITING_SECOND_CHANGE;
#line 235 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
					self->priv->exp_count = 0;
#line 236 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
					_tmp18_ = label;
#line 236 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
					_tmp19_ = g_strdup (_tmp18_);
#line 236 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
					_g_free0 (self->priv->prev_clock_val);
#line 236 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
					self->priv->prev_clock_val = _tmp19_;
#line 989 "clock.c"
				} else {
					ClockInterval _tmp20_ = 0;
#line 241 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
					if (self->priv->exp_count > 3) {
#line 241 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
						_tmp20_ = CLOCK_INTERVAL_ONE_MINUTE;
#line 996 "clock.c"
					} else {
#line 241 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
						_tmp20_ = CLOCK_INTERVAL_ONE_SECOND;
#line 1000 "clock.c"
					}
#line 241 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
					self->priv->exp_interval = _tmp20_;
#line 242 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
					_g_free0 (self->priv->prev_clock_val);
#line 242 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
					self->priv->prev_clock_val = NULL;
#line 1008 "clock.c"
				}
			}
		}
	}
#line 248 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	result = FALSE;
#line 248 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_g_free0 (tooltip);
#line 248 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_g_free0 (label);
#line 248 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_g_date_time_unref0 (now);
#line 248 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	return result;
#line 1023 "clock.c"
}

static gboolean
_clock_update_display_gsource_func (gpointer self)
{
	gboolean result;
	result = clock_update_display ((Clock*) self);
#line 266 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	return result;
#line 1033 "clock.c"
}

static void
clock_timer_set (Clock* self,
                 GDateTime* current_time)
{
	guint microseconds = 0U;
#line 251 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_return_if_fail (self != NULL);
#line 251 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_return_if_fail (current_time != NULL);
#line 253 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	microseconds = (guint) 1000000;
#line 255 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	microseconds = (guint) (1000000 - g_date_time_get_microsecond (current_time));
#line 258 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	if (self->priv->exp_interval == CLOCK_INTERVAL_ONE_MINUTE) {
#line 1051 "clock.c"
		guint seconds = 0U;
#line 260 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		seconds = (guint) (60 - g_date_time_get_second (current_time));
#line 261 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		microseconds += seconds * 1000000;
#line 1057 "clock.c"
	}
#line 264 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	if (microseconds <= ((guint) 0)) {
#line 265 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		microseconds = (guint) 1000000;
#line 1063 "clock.c"
	}
#line 266 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	self->priv->timer = g_timeout_add_full (G_PRIORITY_DEFAULT, microseconds / 1000, _clock_update_display_gsource_func, g_object_ref (self), g_object_unref);
#line 1067 "clock.c"
}

const gchar*
clock_get_clock_format (Clock* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 39 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp0_ = self->priv->_clock_format;
#line 39 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	result = _tmp0_;
#line 39 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	return result;
#line 1083 "clock.c"
}

void
clock_set_clock_format (Clock* self,
                        const gchar* value)
{
	gchar* old_value;
#line 39 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_return_if_fail (self != NULL);
#line 39 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	old_value = clock_get_clock_format (self);
#line 39 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1097 "clock.c"
		gchar* _tmp0_;
#line 39 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_tmp0_ = g_strdup (value);
#line 39 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_g_free0 (self->priv->_clock_format);
#line 39 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		self->priv->_clock_format = _tmp0_;
#line 39 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		g_object_notify_by_pspec ((GObject *) self, clock_properties[CLOCK_CLOCK_FORMAT_PROPERTY]);
#line 1107 "clock.c"
	}
}

const gchar*
clock_get_tooltip_format (Clock* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 40 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_tmp0_ = self->priv->_tooltip_format;
#line 40 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	result = _tmp0_;
#line 40 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	return result;
#line 1124 "clock.c"
}

void
clock_set_tooltip_format (Clock* self,
                          const gchar* value)
{
	gchar* old_value;
#line 40 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_return_if_fail (self != NULL);
#line 40 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	old_value = clock_get_tooltip_format (self);
#line 40 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1138 "clock.c"
		gchar* _tmp0_;
#line 40 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_tmp0_ = g_strdup (value);
#line 40 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		_g_free0 (self->priv->_tooltip_format);
#line 40 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		self->priv->_tooltip_format = _tmp0_;
#line 40 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		g_object_notify_by_pspec ((GObject *) self, clock_properties[CLOCK_TOOLTIP_FORMAT_PROPERTY]);
#line 1148 "clock.c"
	}
}

gboolean
clock_get_bold_font (Clock* self)
{
	gboolean result;
#line 41 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 41 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	result = self->priv->_bold_font;
#line 41 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	return result;
#line 1162 "clock.c"
}

void
clock_set_bold_font (Clock* self,
                     gboolean value)
{
	gboolean old_value;
#line 41 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_return_if_fail (self != NULL);
#line 41 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	old_value = clock_get_bold_font (self);
#line 41 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	if (old_value != value) {
#line 41 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		self->priv->_bold_font = value;
#line 41 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		g_object_notify_by_pspec ((GObject *) self, clock_properties[CLOCK_BOLD_FONT_PROPERTY]);
#line 1180 "clock.c"
	}
}

static void
clock_class_init (ClockClass * klass,
                  gpointer klass_data)
{
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	clock_parent_class = g_type_class_peek_parent (klass);
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_type_class_adjust_private_offset (klass, &Clock_private_offset);
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	((GObjectClass *) klass)->constructed = (void (*) (GObject*)) clock_real_constructed;
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	((ValaPanelAppletClass *) klass)->get_settings_ui = (GtkWidget* (*) (ValaPanelApplet*)) clock_real_get_settings_ui;
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_clock_get_property;
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_clock_set_property;
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	G_OBJECT_CLASS (klass)->finalize = clock_finalize;
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLOCK_CLOCK_FORMAT_PROPERTY, clock_properties[CLOCK_CLOCK_FORMAT_PROPERTY] = g_param_spec_string ("clock-format", "clock-format", "clock-format", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLOCK_TOOLTIP_FORMAT_PROPERTY, clock_properties[CLOCK_TOOLTIP_FORMAT_PROPERTY] = g_param_spec_string ("tooltip-format", "tooltip-format", "tooltip-format", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLOCK_BOLD_FONT_PROPERTY, clock_properties[CLOCK_BOLD_FONT_PROPERTY] = g_param_spec_boolean ("bold-font", "bold-font", "bold-font", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1208 "clock.c"
}

static void
clock_instance_init (Clock * self,
                     gpointer klass)
{
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	self->priv = clock_get_instance_private (self);
#line 1217 "clock.c"
}

static void
clock_finalize (GObject * obj)
{
	Clock * self;
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CLOCK, Clock);
#line 26 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_g_object_unref0 (self->priv->clock);
#line 36 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_g_free0 (self->priv->prev_clock_val);
#line 38 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_g_object_unref0 (self->priv->calendar);
#line 39 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_g_free0 (self->priv->_clock_format);
#line 40 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	_g_free0 (self->priv->_tooltip_format);
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	G_OBJECT_CLASS (clock_parent_class)->finalize (obj);
#line 1238 "clock.c"
}

GType
clock_get_type (void)
{
	return clock_type_id;
}

GType
clock_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClockClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) clock_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Clock), 0, (GInstanceInitFunc) clock_instance_init, NULL };
	clock_type_id = g_type_module_register_type (module, VALA_PANEL_TYPE_APPLET, "Clock", &g_define_type_info, 0);
	Clock_private_offset = sizeof (ClockPrivate);
	return clock_type_id;
}

static void
_vala_clock_get_property (GObject * object,
                          guint property_id,
                          GValue * value,
                          GParamSpec * pspec)
{
	Clock * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CLOCK, Clock);
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	switch (property_id) {
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		case CLOCK_CLOCK_FORMAT_PROPERTY:
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		g_value_set_string (value, clock_get_clock_format (self));
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		break;
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		case CLOCK_TOOLTIP_FORMAT_PROPERTY:
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		g_value_set_string (value, clock_get_tooltip_format (self));
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		break;
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		case CLOCK_BOLD_FONT_PROPERTY:
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		g_value_set_boolean (value, clock_get_bold_font (self));
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		break;
#line 1284 "clock.c"
		default:
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		break;
#line 1290 "clock.c"
	}
}

static void
_vala_clock_set_property (GObject * object,
                          guint property_id,
                          const GValue * value,
                          GParamSpec * pspec)
{
	Clock * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CLOCK, Clock);
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	switch (property_id) {
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		case CLOCK_CLOCK_FORMAT_PROPERTY:
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		clock_set_clock_format (self, g_value_get_string (value));
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		break;
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		case CLOCK_TOOLTIP_FORMAT_PROPERTY:
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		clock_set_tooltip_format (self, g_value_get_string (value));
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		break;
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		case CLOCK_BOLD_FONT_PROPERTY:
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		clock_set_bold_font (self, g_value_get_boolean (value));
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		break;
#line 1322 "clock.c"
		default:
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
		break;
#line 1328 "clock.c"
	}
}

void
g_io_clock_load (GTypeModule* module)
{
#line 271 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_return_if_fail (module != NULL);
#line 271 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	clock_register_type (module);
#line 274 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_io_extension_point_implement (VALA_PANEL_APPLET_EXTENSION_POINT, TYPE_CLOCK, "org.valapanel.clock", 10);
#line 1341 "clock.c"
}

void
g_io_clock_unload (GIOModule* module)
{
#line 277 "/home/abuild/rpmbuild/BUILD/vala-panel-0.4.91/applets/core/clock/clock.vala"
	g_return_if_fail (module != NULL);
#line 1349 "clock.c"
}

